package ch.fritteli.labyrinth.generator.renderer.text;

import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.assertEquals;

class CharDefinitionTest {
    @Test
    void testRenderingWall() {
        assertEquals(" ", new CharDefinition(false, false, false, false, false).toString());
        assertEquals("╶", new CharDefinition(false, false, false, true, false).toString());
        assertEquals("╴", new CharDefinition(false, false, true, false, false).toString());
        assertEquals("─", new CharDefinition(false, false, true, true, false).toString());
        assertEquals("╷", new CharDefinition(false, true, false, false, false).toString());
        assertEquals("┌", new CharDefinition(false, true, false, true, false).toString());
        assertEquals("┐", new CharDefinition(false, true, true, false, false).toString());
        assertEquals("┬", new CharDefinition(false, true, true, true, false).toString());
        assertEquals("╵", new CharDefinition(true, false, false, false, false).toString());
        assertEquals("└", new CharDefinition(true, false, false, true, false).toString());
        assertEquals("┘", new CharDefinition(true, false, true, false, false).toString());
        assertEquals("┴", new CharDefinition(true, false, true, true, false).toString());
        assertEquals("│", new CharDefinition(true, true, false, false, false).toString());
        assertEquals("├", new CharDefinition(true, true, false, true, false).toString());
        assertEquals("┤", new CharDefinition(true, true, true, false, false).toString());
        assertEquals("┼", new CharDefinition(true, true, true, true, false).toString());
    }

    @Test
    void testRenderingSolution() {
        assertEquals(" ", new CharDefinition(false, false, false, false, true).toString());
        assertEquals("╶", new CharDefinition(false, false, false, true, true).toString());
        assertEquals("╴", new CharDefinition(false, false, true, false, true).toString());
        assertEquals("─", new CharDefinition(false, false, true, true, true).toString());
        assertEquals("╷", new CharDefinition(false, true, false, false, true).toString());
        assertEquals("╭", new CharDefinition(false, true, false, true, true).toString());
        assertEquals("╮", new CharDefinition(false, true, true, false, true).toString());
        assertEquals("┬", new CharDefinition(false, true, true, true, true).toString());
        assertEquals("╵", new CharDefinition(true, false, false, false, true).toString());
        assertEquals("╰", new CharDefinition(true, false, false, true, true).toString());
        assertEquals("╯", new CharDefinition(true, false, true, false, true).toString());
        assertEquals("┴", new CharDefinition(true, false, true, true, true).toString());
        assertEquals("│", new CharDefinition(true, true, false, false, true).toString());
        assertEquals("├", new CharDefinition(true, true, false, true, true).toString());
        assertEquals("┤", new CharDefinition(true, true, true, false, true).toString());
        assertEquals("┼", new CharDefinition(true, true, true, true, true).toString());
    }

    @Test
    void testBuilderMethods() {
        assertEquals(new CharDefinition(true, false, false, false, false), new CharDefinition().up());
        assertEquals(new CharDefinition(false, true, false, false, false), new CharDefinition().down());
        assertEquals(new CharDefinition(false, false, true, false, false), new CharDefinition().left());
        assertEquals(new CharDefinition(false, false, false, true, false), new CharDefinition().right());
        assertEquals(new CharDefinition(false, false, false, false, true), new CharDefinition().solution());
        assertEquals(new CharDefinition(true, true, false, false, false), new CharDefinition().vertical());
        assertEquals(new CharDefinition(false, false, true, true, false), new CharDefinition().horizontal());
        assertEquals(new CharDefinition(true, true, true, true, true), new CharDefinition().vertical().horizontal().solution());
    }
}
