package ch.fritteli.labyrinth.generator.serialization;

import ch.fritteli.labyrinth.generator.model.Labyrinth;
import lombok.NonNull;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.assertEquals;

class SerializerDeserializerTest {
    @Test
    void testSerializeDeserializeTiny() {
        @NonNull final Labyrinth expected = new Labyrinth(2, 2, 255);
        @NonNull final byte[] bytes = SerializerDeserializer.serialize(expected);
        @NonNull final Labyrinth result = SerializerDeserializer.deserialize(bytes);
        assertEquals(expected, result);
    }

    @Test
    void testSerializeDeserializeMedium() {
        @NonNull final Labyrinth expected = new Labyrinth(20, 20, -271828182846L);
        @NonNull final byte[] bytes = SerializerDeserializer.serialize(expected);
        @NonNull final Labyrinth result = SerializerDeserializer.deserialize(bytes);
        assertEquals(expected, result);
    }

    @Test
    void testSerializeDeserializeLarge() {
        @NonNull final Labyrinth expected = new Labyrinth(200, 320, 3141592653589793238L);
        @NonNull final byte[] bytes = SerializerDeserializer.serialize(expected);
        @NonNull final Labyrinth result = SerializerDeserializer.deserialize(bytes);
        assertEquals(expected, result);
    }
}
